#include <stdlib.h>
#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <string.h>
#include <unistd.h>

int main()
{
  int sdP;      /* Socket descriptor -- passive socket */
  int sdA;      /* Socket descriptor -- active socket */
  int addrlen;
  int rcvlen;
  int i;
  struct sockaddr_in addrInP; /* Socket address for passive socket */
  struct sockaddr_in addrInA; /* Socket address for active socket */
  char buf[256];

  /* socket */
  sdP = socket(AF_INET, SOCK_STREAM, 0);
  if(sdP == -1)
    {
      perror("socket() failed");
      exit(1);
    }

  memset(&addrInP, 0, sizeof(addrInP));
  addrInP.sin_family = AF_INET;
  addrInP.sin_addr.s_addr = INADDR_ANY;
  addrInP.sin_port = htons(60000);

  /* bind */
  if(bind(sdP, (struct sockaddr*)&addrInP, sizeof(addrInP)) == -1)
    {
      perror("bind() failed");
      exit(1);
    }

  /* listen */
  if(listen(sdP, 5) == -1)
    {
      perror("listen() failed");
      exit(1);
    }

  memset(&addrInA, 0, sizeof(addrInA));
  addrlen = sizeof(addrInA);
  sdA = accept(sdP, (struct sockaddr*)&addrInA, &addrlen);
  if(sdA == -1)
    {
      perror("accept() failed");
      exit(1);
    }

  /* recv */
  while((rcvlen = recv(sdA, buf, sizeof(buf),0)) > 0)
    {
      for(i=0;i<rcvlen;i++)
        {
          putchar(buf[i]);
        }
    }

  /* close */
  close(sdA);
  close(sdP);
  sleep(1);
  return 0;
}
